# Class VulkanImageBlit

java.lang.Object
com.io7m.jcoronado.api.VulkanImageBlit

All Implemented Interfaces:
  `VulkanImageBlitType`

public final class VulkanImageBlit extends Object implements VulkanImageBlitType
Structure specifying an image blit operation.

See Also:
  - "VkImageBlit"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanImageBlit.Builder`
  Builds instances of type `VulkanImageBlit`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanImageBlit.Builder`
  `builder()`
  Creates a builder for `VulkanImageBlit`.
  `static VulkanImageBlit`
  `copyOf(VulkanImageBlitType instance)`
  Creates an immutable copy of a `VulkanImageBlitType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanImageBlit` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `sourceSubresource`, `sourceOffset0`, `sourceOffset1`, `targetSubresource`, `targetOffset0`, `targetOffset1`.
  `VulkanOffset3D`
  `sourceOffset0()`
  `VulkanOffset3D`
  `sourceOffset1()`
  `VulkanImageSubresourceLayers`
  `sourceSubresource()`
  `VulkanOffset3D`
  `targetOffset0()`
  `VulkanOffset3D`
  `targetOffset1()`
  `VulkanImageSubresourceLayers`
  `targetSubresource()`
  `String`
  `toString()`
  Prints the immutable value `VulkanImageBlit` with attribute values.
  `final VulkanImageBlit`
  `withSourceOffset0(VulkanOffset3D value)`
  Copy the current immutable object by setting a value for the `sourceOffset0` attribute.
  `final VulkanImageBlit`
  `withSourceOffset1(VulkanOffset3D value)`
  Copy the current immutable object by setting a value for the `sourceOffset1` attribute.
  `final VulkanImageBlit`
  `withSourceSubresource(VulkanImageSubresourceLayers value)`
  Copy the current immutable object by setting a value for the `sourceSubresource` attribute.
  `final VulkanImageBlit`
  `withTargetOffset0(VulkanOffset3D value)`
  Copy the current immutable object by setting a value for the `targetOffset0` attribute.
  `final VulkanImageBlit`
  `withTargetOffset1(VulkanOffset3D value)`
  Copy the current immutable object by setting a value for the `targetOffset1` attribute.
  `final VulkanImageBlit`
  `withTargetSubresource(VulkanImageSubresourceLayers value)`
  Copy the current immutable object by setting a value for the `targetSubresource` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### sourceSubresource

    public VulkanImageSubresourceLayers sourceSubresource()
    Specified by:
      `sourceSubresource` in interface `VulkanImageBlitType`
    Returns:
      The subresource to blit from

  - ### sourceOffset0

    public VulkanOffset3D sourceOffset0()
    Specified by:
      `sourceOffset0` in interface `VulkanImageBlitType`
    Returns:
      A corner of the source region

  - ### sourceOffset1

    public VulkanOffset3D sourceOffset1()
    Specified by:
      `sourceOffset1` in interface `VulkanImageBlitType`
    Returns:
      A corner of the source region

  - ### targetSubresource

    public VulkanImageSubresourceLayers targetSubresource()
    Specified by:
      `targetSubresource` in interface `VulkanImageBlitType`
    Returns:
      The subresource to blit to

  - ### targetOffset0

    public VulkanOffset3D targetOffset0()
    Specified by:
      `targetOffset0` in interface `VulkanImageBlitType`
    Returns:
      A corner of the target region

  - ### targetOffset1

    public VulkanOffset3D targetOffset1()
    Specified by:
      `targetOffset1` in interface `VulkanImageBlitType`
    Returns:
      A corner of the target region

  - ### withSourceSubresource

    public final VulkanImageBlit withSourceSubresource(VulkanImageSubresourceLayers value)
    Copy the current immutable object by setting a value for the `sourceSubresource` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for sourceSubresource
    Returns:
      A modified copy or the `this` object

  - ### withSourceOffset0

    public final VulkanImageBlit withSourceOffset0(VulkanOffset3D value)
    Copy the current immutable object by setting a value for the `sourceOffset0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for sourceOffset0
    Returns:
      A modified copy or the `this` object

  - ### withSourceOffset1

    public final VulkanImageBlit withSourceOffset1(VulkanOffset3D value)
    Copy the current immutable object by setting a value for the `sourceOffset1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for sourceOffset1
    Returns:
      A modified copy or the `this` object

  - ### withTargetSubresource

    public final VulkanImageBlit withTargetSubresource(VulkanImageSubresourceLayers value)
    Copy the current immutable object by setting a value for the `targetSubresource` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for targetSubresource
    Returns:
      A modified copy or the `this` object

  - ### withTargetOffset0

    public final VulkanImageBlit withTargetOffset0(VulkanOffset3D value)
    Copy the current immutable object by setting a value for the `targetOffset0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for targetOffset0
    Returns:
      A modified copy or the `this` object

  - ### withTargetOffset1

    public final VulkanImageBlit withTargetOffset1(VulkanOffset3D value)
    Copy the current immutable object by setting a value for the `targetOffset1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for targetOffset1
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanImageBlit` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `sourceSubresource`, `sourceOffset0`, `sourceOffset1`, `targetSubresource`, `targetOffset0`, `targetOffset1`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanImageBlit` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanImageBlit copyOf(VulkanImageBlitType instance)
    Creates an immutable copy of a `VulkanImageBlitType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanImageBlit instance

  - ### builder

    public static VulkanImageBlit.Builder builder()
    Creates a builder for `VulkanImageBlit`.

        VulkanImageBlit.builder()
           .setSourceSubresource(com.io7m.jcoronado.api.VulkanImageSubresourceLayers) // required sourceSubresource
           .setSourceOffset0(com.io7m.jcoronado.api.VulkanOffset3D) // required sourceOffset0
           .setSourceOffset1(com.io7m.jcoronado.api.VulkanOffset3D) // required sourceOffset1
           .setTargetSubresource(com.io7m.jcoronado.api.VulkanImageSubresourceLayers) // required targetSubresource
           .setTargetOffset0(com.io7m.jcoronado.api.VulkanOffset3D) // required targetOffset0
           .setTargetOffset1(com.io7m.jcoronado.api.VulkanOffset3D) // required targetOffset1
           .build();

    Returns:
      A new VulkanImageBlit builder